Description

I think I've found an issue with how Foreman deals with DNS entries for Openstack VMs.

The DNS records (A record and PTR record) for VMs are created correctly, with the floating IP being used for both records. However,

when a VM is deleted, Foreman sometimes tries to delete a PTR record with the fixed IP, which obviously doesn't exist. This leads to

old PTR records not being cleaned up and eventually DNS conflicts when new VMs are created.

I've grabbed the relevant entries from the Foreman proxy log. Here is the VM being created:

DEBUG – : running /usr/bin/nsupdate -k /var/named/chroot/etc/Kforeman.+157+35782.private

DEBUG – : nsupdate: executed - server 172.25.96.7

DEBUG – : nsupdate: executed - update add 7.120.25.172.in-addr.arpa. 86400 IN PTR newtest.office.example.com

DEBUG – : running /usr/bin/nsupdate -k /var/named/chroot/etc/Kforeman.+157+35782.private

DEBUG – : nsupdate: executed - server 172.25.96.7

DEBUG – : nsupdate: executed - update add newtest.office.example.com. 86400 A 172.25.120.7

Note it's using 172.25.120.7, which is the floating IP for the VM.

Now the log from when the VM is deleted:

DEBUG – : running /usr/bin/nsupdate -k /var/named/chroot/etc/Kforeman.+157+35782.private

DEBUG – : nsupdate: executed - server 172.25.96.7

DEBUG – : nsupdate: executed - update delete newtest.office.example.com A

DEBUG – : running /usr/bin/nsupdate -k /var/named/chroot/etc/Kforeman.+157+35782.private

DEBUG – : nsupdate: executed - server 172.25.96.7

DEBUG – : nsupdate: executed - update delete 4.96.25.172.in-addr.arpa PTR

Here it tries to delete a PTR record for 127.25.96.4, which is the fixed IP address of the VM. As that record was never created the

operation fails, and the correct PTR record isn't cleaned up.

This is with Foreman 1.3.0.

History

#1 - 11/04/2013 02:50 PM - Andy Taylor

Forgot to add that this doesn't happen every time. Sometimes it uses the floating IP when it deletes the PTR record, sometimes it doesn't.

#2 - 11/08/2013 01:46 PM - Andy Taylor

Turns out this was an issue with our own DNS configuration, nothing to do with Foreman. Sorry, this can be closed!

#3 - 11/08/2013 01:51 PM - Dominic Cleal

- Status changed from New to Rejected

Thanks for letting us know!
